task ReadFilter {
    
    String sample_ID
    File in_fastq
    Int qualified_quality_phred
    Int unqualified_percent_limit
    Int n_base_limit
    Int length_required

 
    String docker
    String cluster_config
    String disk_size


    command <<<
        set -o pipefail
        set -e
        nt=$(nproc)

        fastp --thread $nt -A \
            --qualified_quality_phred ${qualified_quality_phred} --unqualified_percent_limit ${unqualified_percent_limit} \
            --n_base_limit ${n_base_limit} \
            --length_required ${length_required} \
            -i ${in_fastq} \
            -o ${sample_ID}.trimAdapt.filter.fastq.gz \
            2> ${sample_ID}.filter.log
        >>>

    runtime {
        docker: docker
        cluster: cluster_config
        systemDisk: "cloud_ssd 40"
        dataDisk: "cloud_ssd " + disk_size + " /cromwell_root/"
    }

    output {
        File out_fastq="${sample_ID}.trimAdapt.filter.fastq.gz"
        File out_log="${sample_ID}.filter.log"
    }
}
